<template>  
<div style="overflow:auto;">
    <div :class="['app-list','test-ctrl-style',this.items.length > 0 ? '' : 'app-list-empty' ]">
            	<div>
		<span style="color: red"> 列表插件自定义内容 </span>
		<AppList
			:id="controlID"
			:class="classNames"
			:items="store.data"
			:selections="store.selections"
			:totalRecord="store.totalRecord"
			@item-click="handleItemClick"
			@item-db-click="handleItemDbClick"
			@selection-change="handleSelectionChange"
			@load-more="handleLoadMore"
			@item-action-click="(logic: any, data: IParam, event: MouseEvent) => handleActionClick(controller, logic, data, event)"
		>
		</AppList>
	</div>
    </div>
    <row class='list-pagination' v-if="selections.length > 0">
        <span class="batch-toolbar">
                    <div class='toolbar-container'>
                <tooltip :transfer="true" :max-width="600">
                        <i-button v-show="usr7listview_listpluginlist_batchtoolbarModels.deuiaction1.visabled" :disabled="usr7listview_listpluginlist_batchtoolbarModels.deuiaction1.disabled" class='' v-button-loading:i-button @click="list_batchtoolbar_click({ tag: 'deuiaction1' }, $event)">
                            <i class='fa fa-edit'></i>
                            <span class='caption'>{{$t('entities.ibizbook.usr7listview_listpluginlist_batchtoolbar_toolbar.deuiaction1.caption')}}</span>
                        </i-button>
                    <div slot='content'>{{$t('entities.ibizbook.usr7listview_listpluginlist_batchtoolbar_toolbar.deuiaction1.tip')}}</div>
                </tooltip>
                <tooltip :transfer="true" :max-width="600">
                        <i-button v-show="usr7listview_listpluginlist_batchtoolbarModels.deuiaction2.visabled" :disabled="usr7listview_listpluginlist_batchtoolbarModels.deuiaction2.disabled" class='' v-button-loading:i-button @click="list_batchtoolbar_click({ tag: 'deuiaction2' }, $event)">
                            <i class='fa fa-remove'></i>
                            <span class='caption'>{{$t('entities.ibizbook.usr7listview_listpluginlist_batchtoolbar_toolbar.deuiaction2.caption')}}</span>
                        </i-button>
                    <div slot='content'>{{$t('entities.ibizbook.usr7listview_listpluginlist_batchtoolbar_toolbar.deuiaction2.tip')}}</div>
                </tooltip>
            </div>
        </span>
    </row>
</div>
</template>
// 基于 @CONTROL/列表/CONTROL-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZBOOKEntityService from '@/service/ibizbook/ibizbook-service';
import ListpluginService from './listplugin-list-service';
import IBIZBOOKUIService from '@/uiservice/ibizbook/ibizbook-ui-service';
import CodeListService from "@/codelist/codelist-service";


@Component({
    components: {
      
    }
})
export default class ListpluginBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof ListpluginBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof ListpluginBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof ListpluginBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof ListpluginBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数(父级)
     *
     * @type {*}
     * @memberof ListpluginBase
     */
    @Prop() public pViewCtx!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof ListpluginBase
     */
    public viewCtx: any = {};

    /**
     * 监听视图操作参数变化
     *
     * @type {*}
     * @memberof ListpluginBase
     */
    @Watch('pViewCtx', { immediate: true })
    public onViewCtxChange(newVal: any, oldVal: any) {
        Object.assign(this.viewCtx, newVal, { xData: this, ctrl: this });
    }

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ListpluginBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof ListpluginBase
     */
    public getControlType(): string {
        return 'LIST'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof ListpluginBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {ListpluginService}
     * @memberof ListpluginBase
     */
    public service: ListpluginService = new ListpluginService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZBOOKService}
     * @memberof ListpluginBase
     */
    public appEntityService: IBIZBOOKEntityService = new IBIZBOOKEntityService({ $store: this.$store });

    /**
     * list_quicktoolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ListpluginBase
     */
    public list_quicktoolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction1')) {
            this.list_quicktoolbar_deuiaction1_click(null, 'list_quicktoolbar', $event2);
        }
    }

    /**
     * list_batchtoolbar 部件 click 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof ListpluginBase
     */
    public list_batchtoolbar_click($event: any, $event2?: any) {
        if (Object.is($event.tag, 'deuiaction1')) {
            this.list_batchtoolbar_deuiaction1_click(null, 'list_batchtoolbar', $event2);
        }
        if (Object.is($event.tag, 'deuiaction2')) {
            this.list_batchtoolbar_deuiaction2_click(null, 'list_batchtoolbar', $event2);
        }
    }
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_quicktoolbar_deuiaction1_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.New(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_batchtoolbar_deuiaction1_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Edit(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_batchtoolbar_deuiaction2_click(params: any = {}, tag?: any, $event?: any) {
        // 参数
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Remove(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_memo1_u37f11a8_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Edit(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public list_memo1_uc365542_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        this.Remove(datas, contextJO,paramJO,  $event, xData,this,"IBIZBOOK");
    }

    /**
     * 新建
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKUsr7ListView_listPluginBase
     */
    public New(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
         const _this: any = this;
        if (_this.newdata && _this.newdata instanceof Function) {
            const data: any = {};
            _this.newdata([{ ...data }],[{ ...data }], params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'newdata 视图处理逻辑不存在，请添加!' });
        }
    }
    /**
     * 编辑
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKUsr7ListView_listPluginBase
     */
    public Edit(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        if (args.length === 0) {
            return;
        }
        const _this: any = this;
        if (_this.opendata && _this.opendata instanceof Function) {
            const data: any = { };
            if (args.length > 0) {
                Object.assign(data, { ibizbook: args[0].ibizbook })
            }
            _this.opendata([{ ...data }], args, params, $event, xData);
        } else {
            _this.$Notice.error({ title: '错误', desc: 'opendata 视图处理逻辑不存在，请添加!' });
        }
    }
    /**
     * 删除
     *
     * @param {any[]} args 当前数据
     * @param {any} contextJO 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @memberof IBIZBOOKUsr7ListView_listPluginBase
     */
    public Remove(args: any[],contextJO?:any, params?: any, $event?: any, xData?: any,actionContext?:any,srfParentDeName?:string) {
        const _this: any = this;
        if (!xData || !(xData.remove instanceof Function)) {
            return ;
        }
        xData.remove(args);
    }


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  ListpluginBase
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof ListpluginBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof ListpluginBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof ListpluginBase
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        Object.assign(actionData, args);
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }


    import { AppList } from '@components/widgets/list';
import {
	ICtrlDataAction,
	IContext,
	IParam,
	ListActionType,
	IListAbility,
	ListController,
	createUUID,
	ILoadingHelper,
	IViewCtx,
} from '@/core';
import {
	getCtrlClassNames,
	useEventBind,
	handleActionClick,
} from '@/hooks/use-ctrl';
interface Props {
	name?: string;
	context: IContext;
	viewParams: IParam;
	localContext?: IParam;
	localViewParams?: IParam;
	closeView?: Function;
	pLoadingHelper?: ILoadingHelper;
	pViewCtx?: IViewCtx;
	openView?: Function;
	newView?: Function;
	actions: ICtrlDataAction;
	singleSelect?: boolean;
	rowActiveMode?: 0 | 1 | 2;
	selectFirstDefault?: boolean;
	controller: ListController;
}

const props = withDefaults(defineProps<Props>(), {
	singleSelect: false,
	rowActiveMode: 2,
});
const emit = defineEmits<{
	(
		event: 'ctrl-action',
		name: string,
		action: ListActionType,
		data: IParam[]
	): void;
	(event: 'ctrl-init', name: string, data: IListAbility): void;
	(event: 'ctrl-destroy', name: string, data: IParam): void;
}>();

const evt = useEventBind<ListActionType, IListAbility>(emit);
//  部件样式名
const classNames = computed(() => {
	return getCtrlClassNames(model, props);
});

const controlID = createUUID();

const model: IParam = props.controller.getModel();
const handleItemClick = (row: IParam, event: MouseEvent) => {
	props.controller.handleItemClick(row, event);
};
const store = props.controller.getStore();

const handleItemDbClick = (row: IParam, event: MouseEvent) => {
	props.controller.handleItemDbClick(row, event);
};

const handleSelectionChange = (selections: IParam[]) => {
	props.controller.handleSelectionChange(selections);
};

const handleLoadMore = () => {
	props.controller.loadMore();
};


    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof ListpluginBase
     */  
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZBOOKUIService}
     * @memberof ListpluginBase
     */  
    public appUIService:IBIZBOOKUIService = new IBIZBOOKUIService();

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ListpluginBase
     */
    public getDatas(): any[] {
        return this.selections;
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ListpluginBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 是否默认选中第一条数据
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    @Prop({ default: false }) public isSelectFirstDefault!: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof ListpluginBase
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof ListpluginBase
     */
    @Prop() public removeAction!: string;

    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof ListpluginBase
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--fetch
     *
     * @type {string}
     * @memberof ListpluginBase
     */
    @Prop() public fetchAction!: string;

    /**
     * 父引用类型
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    @Prop({default:true}) public parentType: any;;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof ListpluginBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof ListpluginBase
     */
    @Prop() public opendata: any;

    /**
     * this引用
     *
     * @type {number}
     * @memberof ListpluginBase
     */
    public thisRef: any = this;




          /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZBOOKUsr7ListView_listPlugin
     */
    public usr7listview_listpluginlist_quicktoolbarModels: any = {
        deuiaction1: { name: 'deuiaction1', actiontarget: 'NONE', caption: '新建', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'New', target: '' } },

    };


          /**
     * 工具栏模型
     *
     * @type {*}
     * @memberof IBIZBOOKUsr7ListView_listPlugin
     */
    public usr7listview_listpluginlist_batchtoolbarModels: any = {
        deuiaction1: { name: 'deuiaction1', actiontarget: 'NONE', caption: '编辑', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Edit', target: 'SINGLEKEY' } },

        deuiaction2: { name: 'deuiaction2', actiontarget: 'NONE', caption: '删除', disabled: false, type: 'DEUIACTION', visabled: true,noprivdisplaymode:2,dataaccaction: '', uiaction: { tag: 'Remove', target: 'MULTIKEY' } },

    };


    /**
     * 当前页
     *
     * @type {number}
     * @memberof ListpluginBase
     */
    public curPage: number = 1;

    /**
     * 数据
     *
     * @type {any[]}
     * @memberof ListpluginBase
     */
    public items: any[] = [];

    /**
     * 是否支持分页
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    public isEnablePagingBar: boolean = true;

    /**
     * 分页条数
     *
     * @type {number}
     * @memberof ListpluginBase
     */
    public limit: number = 10;

    /**
     * 总条数
     *
     * @type {number}
     * @memberof ListpluginBase
     */
    public totalRecord: number = 0;

    /**
     * 加载的数据是否附加在items之后
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    public isAddBehind:boolean = false;

    /**
     * 是否有滚动条
     *
     * @type {boolean}
     * @memberof ListpluginBase
     */
    public isScrollBar: boolean = false;

    /**
     * 排序方向
     *
     * @type {string}
     * @memberof ListpluginBase
     */    
    public sortDir:string = 'asc';

    /**
     * 排序字段
     *
     * @type {string}
     * @memberof ListpluginBase
     */    
    public sortField: string = 'ibizbookname';

    /**
     * 选中数组
     * @type {Array<any>}
     * @memberof ListpluginBase
     */
    public selections: Array<any> = [];

    /**
     * 应用状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof ListpluginBase
     */
    public appStateEvent: Subscription | undefined;

     /**
     * Vue声明周期，组件挂载完毕
     *
     * @memberof ListpluginBase
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof ListpluginBase
     */
    public afterMounted () {
        const loadMoreCallBack:any = this.throttle(this.loadMore,3000);
        let listDom = this.$el.children[0];
        listDom.addEventListener('scroll', ()=> {
            if(this.$el.scrollHeight > this.$el.clientHeight) {
                this.isScrollBar = true;
            } else {
                this.isScrollBar = false;
            }
            if( this.$el.scrollTop +  this.$el.clientHeight  >=  this.$el.scrollHeight) {
                loadMoreCallBack();
            }
        })
    }

    /**
     * Vue声明周期，组件创建完毕
     *
     * @memberof ListpluginBase
     */
    public created() {
        this.afterCreated()
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ListpluginBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(this.name, tag)) {
                    return;
                }
                if (Object.is(action,'load')) {
                    this.curPage = 1;
                    this.items = [];
                    this.load(data);
                }
                if (Object.is(action,'refresh')) {
                    this.refresh(data);
                }
            });
        }
        if(AppCenterService && AppCenterService.getMessageCenter()){
            this.appStateEvent = AppCenterService.getMessageCenter().subscribe(({ name, action, data }) =>{
                if(!Object.is(name,"IBIZBOOK")){
                    return;
                }
                if(Object.is(action,'appRefresh')){
                    this.refresh([data]);
                }
            })
        }
    }    

    /**
     * vue 生命周期
     *
     * @memberof ListpluginBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ListpluginBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if(this.appStateEvent){
            this.appStateEvent.unsubscribe();
        }
    }    

    /**
    * 加载更多
    *
    * @memberof ListpluginBase
    */
    public loadMore(){
        if(this.totalRecord>this.items.length){
            this.curPage = ++this.curPage;
            this.isAddBehind = true;
            this.load({});
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof Main
     */
    public refresh(args?: any) {
        this.isAddBehind = true;
        this.load(args);
    }

    /**
     * 列表数据加载
     *
     * @public
     * @param {*} [arg={}]
     * @memberof ListpluginBase
     */
    public async load(opt: any = {}): Promise<any> {
        if(!this.fetchAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKUsr7ListView_listPlugin' + (this.$t('app.list.notConfig.fetchAction') as string) });
            return;
        }        
        const arg: any = {...opt};
        const page: any = {};
        if (this.isEnablePagingBar) {
            Object.assign(page, { page: this.curPage-1, size: this.limit });
        }
        // 设置排序
        if (!Object.is(this.sortDir, '') && !Object.is(this.sortField, '')) {
          const sort: string = this.sortField+","+this.sortDir;
            Object.assign(page, { sort: sort });
        }
        Object.assign(arg, page);
        const parentdata: any = {};
        this.$emit('beforeload', parentdata);
        Object.assign(arg, parentdata);
        let tempViewParams:any = parentdata.viewparams ? parentdata.viewparams : {};
        if(this.viewparams){
            Object.assign(tempViewParams,JSON.parse(JSON.stringify(this.viewparams)));
        }
        Object.assign(arg, { viewparams: tempViewParams });
        const tempContext: any = Util.deepCopy(this.context);
        if (!(await this.handleCtrlEvents('onbeforeload', { data: arg }))) {
            return false;
        }
        try {
            const response: any = await this.service.search(this.fetchAction, tempContext, arg, this.showBusyIndicator);
            if (!response || response.status !== 200) {
                if (!(await this.handleCtrlEvents('onloaderror', { data: response && response.data ? response.data : arg }))) {
                    return;
                }
                if (response.data && response.data.message) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data.message });
                }
                return response;
            }
            if (!(await this.handleCtrlEvents('onloadsuccess', { data: response.data }))) {
                return;
            }
            const data: any = response.data;
            if(!this.isAddBehind){
                this.items = [];
            }
            if (data && data.length > 0) {
                let datas = JSON.parse(JSON.stringify(data));
                datas.map((item: any) => {
                    Object.assign(item, { isselected: false });
                });
                this.totalRecord = response.total;
                this.items.push(...datas);
                this.items = this.arrayNonRepeatfy(this.items);
            }
            this.isAddBehind = false;
            this.items.forEach((item: any) => {
                Object.assign(item,this.getActionState(item));    
            })
            this.$emit('load', this.items);
            //在导航视图中，如已有选中数据，则右侧展开已选中数据的视图，如无选中数据则默认选中第一条
            if(this.isSelectFirstDefault){
                if(this.selections && this.selections.length > 0){
                    this.selections.forEach((select: any)=>{
                        const index = this.items.findIndex((item:any) => Object.is(item.srfkey,select.srfkey));
                        if(index != -1){
                            this.handleClick(this.items[index]);
                        }
                    })
                }else{
                    this.handleClick(this.items[0]);
                } 
            }
            return response;
        } catch (response: any) {
            if (!(await this.handleCtrlEvents('onloaderror', { data: response && response.data ? response.data : arg }))) {
                return;
            }
            if (response && response.status === 401) {
                return;
            }
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: response.data && response.data.message ? response.data.message : "" });
        }
    }

    /**
     * 列表数据去重
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof ListpluginBase
     */
    public arrayNonRepeatfy(arr:Array<any>) {
        let map = new Map();
        let array = new Array();
        for (let i = 0; i < arr.length; i++) {
            map .set(arr[i].srfkey, arr[i]); 
        }
        map.forEach((value:any, key:string, map:any) => {
            array.push(value);
        });
        return array ;
    }

    /**
     * 节流
     *
     * @param {Array<any>} [arr]
     * @returns {void}
     * @memberof ListpluginBase
     */
    public throttle(fn:any, wait:number){
        let time = 0;
        return () =>{
          let now = Date.now()
          let args = arguments;
          if(now - time > wait){
            fn.apply(this, args)
            time = now;
          }
        }
    }

    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof ListpluginBase
     */
    public async remove(datas: any[]): Promise<any> {
        if(!this.removeAction){
            this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKUsr7ListView_listPlugin' + (this.$t('app.list.notConfig.removeAction') as string) });
            return;
        }
        if (datas.length === 0) {
            return;
        }
        let dataInfo = '';
        datas.forEach((record: any, index: number) => {
            let srfmajortext = record.srfmajortext;
            if (index < 5) {
                if (!Object.is(dataInfo, '')) {
                    dataInfo += '、';
                }
                dataInfo += srfmajortext;
            } else {
                return false;
            }
        });

        if (datas.length < 5) {
            dataInfo = dataInfo + ' 共' + datas.length + '条数据';
        } else {
            dataInfo = dataInfo + '...' + ' 共' + datas.length + '条数据';
        }

        const removeData = async () => {
            let keys: any[] = [];
            datas.forEach((data: any) => {
                keys.push(data.srfkey); 
            });
            let _removeAction = keys.length > 1 ? 'removeBatch' : this.removeAction ;
            const context:any = JSON.parse(JSON.stringify(this.context));
            if (!(await this.handleCtrlEvents('onbeforeremove', { data: this.items }))) {
                return;
            }
            try {
                const response: any = await this.service.delete(_removeAction,Object.assign(context,{ ibizbook: keys.join(';') }),Object.assign({ ibizbook: keys.join(';') },{viewparams:this.viewparams}), this.showBusyIndicator);
                if (!response || response.status !== 200) {
                    if (!(await this.handleCtrlEvents('onremoveerror', { data: response && response.data ? response.data : datas }))) {
                        return;
                    }
                    this.$Notice.error({ title: '', desc: (this.$t('app.commonWords.delDataFail') as string) + ',' + response.info });
                    return;
                }
                if (!(await this.handleCtrlEvents('onremovesuccess', { data: response.data }))) {
                    return;
                }
                this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.deleteSuccess') as string) });
                //删除items中已删除的项
                datas.forEach((data: any) => {
                    this.items.some((item:any,index:number)=>{
                        if(Object.is(item.srfkey,data.srfkey)){
                            this.items.splice(index,1);
                            return true;
                        }
                    });
                });
                this.$emit('remove', null);
                this.selections = [];
                return response;
            } catch (response: any) {
                if (!(await this.handleCtrlEvents('onremoveerror', { data: response && response.data ? response.data : datas }))) {
                    return;
                }
                if (response && response.status === 401) {
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: (this.$t('app.commonWords.sysException') as string) });
                }
                return response;
            }
        }

        dataInfo = dataInfo.replace(/[null]/g, '').replace(/[undefined]/g, '').replace(/[ ]/g, '');
        this.$Modal.confirm({
            title: (this.$t('app.commonWords.warning') as string),
            content: (this.$t('app.list.confirmDel') as string) + ' ' + dataInfo + '，' + (this.$t('app.list.notRecoverable') as string) ,
            onOk: () => {
                removeData();
            },
            onCancel: () => { }
        });
        return removeData;
    }

    /**
     * 保存
     *
     * @param {*} $event
     * @returns {Promise<any>}
     * @memberof ListpluginBase
     */
    public async save(args: any[], params?: any, $event?: any, xData?: any){
        let _this = this;
        let successItems:any = [];
        let errorItems:any = [];
        let errorMessage:any = [];
        if (!(await this.handleCtrlEvents('onbeforesave'))) {
            return;
        }
        for (const item of _this.items) {
            try {
                if(Object.is(item.rowDataState, 'create')){
                    if(!this.createAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.wrong') as string), desc: 'IBIZBOOKUsr7ListView_listPlugin' + (this.$t('app.list.notConfig.createAction') as string) });
                    }else{
                      Object.assign(item,{viewparams:this.viewparams});
                      let response = await this.service.add(this.createAction, JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                      successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }else if(Object.is(item.rowDataState, 'update')){
                    if(!this.updateAction){
                        this.$Notice.error({ title: (this.$t('app.commonWords.warning') as string), desc: 'IBIZBOOKUsr7ListView_listPlugin' + (this.$t('app.list.notConfig.updateAction') as string) });
                    }else{
                        Object.assign(item,{viewparams:this.viewparams});
                        if(item.ibizbook){
                            Object.assign(this.context,{ibizbook:item.ibizbook});
                        }
                        let response = await this.service.add(this.updateAction,JSON.parse(JSON.stringify(this.context)),item, this.showBusyIndicator);
                        successItems.push(JSON.parse(JSON.stringify(response.data)));
                    }
                }
            } catch (error) {
                errorItems.push(JSON.parse(JSON.stringify(item)));
                errorMessage.push(error);
            }
        }
        this.$emit('save', successItems);
        this.refresh();
        if(errorItems.length === 0){
            if (!(await this.handleCtrlEvents('onsavesuccess', { data: successItems }))) {
                return;
            }
            this.$Notice.success({ title: '', desc: (this.$t('app.commonWords.saveSuccess') as string) });
        } else {
            if (!(await this.handleCtrlEvents('onsaveerror', { data: successItems }))) {
                return;
            }
          errorItems.forEach((item:any,index:number)=>{
            this.$Notice.error({ title: (this.$t('app.commonWords.saveFailed') as string), desc: item.majorentityname+ (this.$t('app.commonWords.saveFailed') as string) + '!' });
            console.error(errorMessage[index]);
          });
        }
        return successItems;
    }

    /**
     * 面板数据变化处理事件
     * @param {any} item 当前列数据
     * @param {any} $event 面板事件数据
     *
     * @memberof ListpluginBase
     */
    public onPanelDataChange(item:any,$event:any) {
        Object.assign(item, $event, {rowDataState:'update'});
    }

    /**
     * 选择数据
     * @memberof ListpluginBase
     *
     */
    public handleClick(args: any) {
        if(this.parentType && this.parentType === "listExpBar") {
            const flag = args.isselected;
            this.clearSelection();
            if(!flag) {
                args.isselected = !args.isselected;
            } else {
                args.isselected = flag;
            }
        } else {
            args.isselected = !args.isselected;
        }
        this.selectchange();
    }

    /**
     * 双击数据
     * @memberof ListpluginBase
     *
     */
    public handleDblClick(args: any) {
        this.$emit('rowdblclick', args);
    }

    /**
     * 触发事件
     * @memberof ListpluginBase
     *
     */
    public selectchange() {
        this.handleCtrlEvents('onselectionchange').then((res: boolean) => {
            if (!res) {
                return;
            }
            this.selections = [];
            this.items.map((item: any) => {
                if (item.isselected) {
                    this.selections.push(item);
                }
            });
            this.$emit('selectionchange', this.selections);
        })
    }

    /**
     * 清除当前所有选中状态
     *
     * @memberof ListpluginBase
     */
    public clearSelection(){
        this.items.map((item: any) => {
            Object.assign(item, { isselected: false });
        }); 
    }

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof ListpluginBase
     */ 
    public actionModel:any ={
         "Edit":{name:"Edit",icon:"fa fa-edit",caption:"编辑",disabled: false, visabled: true,noprivdisplaymode:2,dataaccaction: "", actiontarget: "SINGLEKEY"},
         "Remove":{name:"Remove",icon:"fa fa-remove",caption:"删除",disabled: false, visabled: true,noprivdisplaymode:2,dataaccaction: "", actiontarget: "MULTIKEY"},
    };

    /**
     * 操作列界面行为
     *
     * @param {*} data
     * @param {*} tag
     * @param {*} $event
     * @memberof ListpluginBase
     */
	public uiAction(data: any, tag: any, $event: any) {
        $event.stopPropagation();
        if(Object.is('New', tag)) {
            this.list_quicktoolbar_deuiaction1_click(data, tag, $event);
        }
        if(Object.is('Edit', tag)) {
            this.list_batchtoolbar_deuiaction1_click(data, tag, $event);
        }
        if(Object.is('Remove', tag)) {
            this.list_batchtoolbar_deuiaction2_click(data, tag, $event);
        }
        if(Object.is('Edit', tag)) {
            this.list_memo1_u37f11a8_click(data, tag, $event);
        }
        if(Object.is('Remove', tag)) {
            this.list_memo1_uc365542_click(data, tag, $event);
        }
    }

    /**
     * 获取界面行为权限状态
     *
     * @param {*} data 当前列表行数据
     * @memberof ListpluginBase
     */
    public getActionState(data:any){
        let tempActionModel:any = JSON.parse(JSON.stringify(this.actionModel));
        let targetData:any = this.transformData(data);
        ViewTool.calcActionItemAuthState(targetData,tempActionModel,this.appUIService);
        return tempActionModel;
    }

}
</script>

<style lang='less'>
@import './listplugin-list.less';
</style>